﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectBulldozer.Entities;

/// <summary>
/// Класс-сущность "Бульдозер"
/// </summary>
public class EntityDozer
{
    ///<summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    ///<summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    ///<summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }

    ///<summary>
    /// Дополнительный цвет 
    /// </summary>
    public Color AdditionalColor { get; private set; }

    ///<summary>
    /// Шаг перемещения бульдозера
    /// </summary>
    public double Step => Speed * 100 / Weight;

    ///<summary>
    /// Конструктор
    /// </summary>
    ///<param name="speed">Скорость</param>
    ///<param name="weight">Вес</param>
    ///<param name="bodyColor">Основной цвет</param>
    ///<param name="additionalColor">Дополнительный цвет</param>
    public EntityDozer(int speed, double weight, Color bodyColor, Color additionalColor) 
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;
    }

}
