﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectBulldozer.MovementStrategy;

public class MoveToBorderRB : AbstractStrategy
{

    protected override bool IsTargetDestinaion()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return false;
        }

        return objParams.RightBorder + GetStep() >= FieldWidth && objParams.LeftBorder + GetStep() >= FieldHeight;
    }

    protected override void MoveToTarget()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return;
        }

        int diffX = objParams.RightBorder - FieldWidth;
        if (Math.Abs(diffX) > GetStep())
        {
            MoveRight();
        }

        int diffY = objParams.BottomBorder - FieldHeight;
        if (Math.Abs(diffY) > GetStep())
        {
            MoveDown();
        }
    }
}
